"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.initWormhole = exports.upgradeGuardianSet = void 0;
// Guardian set upgrade
const upgradeGuardianSet = (coreBridgeAddress, vaa) => {
    if (!coreBridgeAddress)
        throw new Error("Need core bridge address.");
    return {
        function: `${coreBridgeAddress}::guardian_set_upgrade::submit_vaa_entry`,
        type_arguments: [],
        arguments: [vaa],
    };
};
exports.upgradeGuardianSet = upgradeGuardianSet;
// Init WH
const initWormhole = (coreBridgeAddress, chainId, governanceChainId, governanceContract, initialGuardian) => {
    if (!coreBridgeAddress)
        throw new Error("Need core bridge address.");
    return {
        function: `${coreBridgeAddress}::wormhole::init`,
        type_arguments: [],
        arguments: [chainId, governanceChainId, governanceContract, initialGuardian],
    };
};
exports.initWormhole = initWormhole;
