import type { BaseContract, BigNumber, BigNumberish, BytesLike, CallOverrides, ContractTransaction, PayableOverrides, PopulatedTransaction, Signer, utils } from "ethers";
import type { FunctionFragment, Result } from "@ethersproject/abi";
import type { Listener, Provider } from "@ethersproject/providers";
import type { TypedEventFilter, TypedEvent, TypedListener, OnEvent, PromiseOrValue } from "../common";
export interface DummyContractInterface extends utils.Interface {
    functions: {
        "forward(uint16,address,uint256,uint256,bytes)": FunctionFragment;
    };
    getFunction(nameOrSignatureOrTopic: "forward"): FunctionFragment;
    encodeFunctionData(functionFragment: "forward", values: [
        PromiseOrValue<BigNumberish>,
        PromiseOrValue<string>,
        PromiseOrValue<BigNumberish>,
        PromiseOrValue<BigNumberish>,
        PromiseOrValue<BytesLike>
    ]): string;
    decodeFunctionResult(functionFragment: "forward", data: BytesLike): Result;
    events: {};
}
export interface DummyContract extends BaseContract {
    connect(signerOrProvider: Signer | Provider | string): this;
    attach(addressOrName: string): this;
    deployed(): Promise<this>;
    interface: DummyContractInterface;
    queryFilter<TEvent extends TypedEvent>(event: TypedEventFilter<TEvent>, fromBlockOrBlockhash?: string | number | undefined, toBlock?: string | number | undefined): Promise<Array<TEvent>>;
    listeners<TEvent extends TypedEvent>(eventFilter?: TypedEventFilter<TEvent>): Array<TypedListener<TEvent>>;
    listeners(eventName?: string): Array<Listener>;
    removeAllListeners<TEvent extends TypedEvent>(eventFilter: TypedEventFilter<TEvent>): this;
    removeAllListeners(eventName?: string): this;
    off: OnEvent<this>;
    on: OnEvent<this>;
    once: OnEvent<this>;
    removeListener: OnEvent<this>;
    functions: {
        forward(chainId: PromiseOrValue<BigNumberish>, targetAddress: PromiseOrValue<string>, gasLimit: PromiseOrValue<BigNumberish>, receiverValue: PromiseOrValue<BigNumberish>, payload: PromiseOrValue<BytesLike>, overrides?: PayableOverrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
    };
    forward(chainId: PromiseOrValue<BigNumberish>, targetAddress: PromiseOrValue<string>, gasLimit: PromiseOrValue<BigNumberish>, receiverValue: PromiseOrValue<BigNumberish>, payload: PromiseOrValue<BytesLike>, overrides?: PayableOverrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    callStatic: {
        forward(chainId: PromiseOrValue<BigNumberish>, targetAddress: PromiseOrValue<string>, gasLimit: PromiseOrValue<BigNumberish>, receiverValue: PromiseOrValue<BigNumberish>, payload: PromiseOrValue<BytesLike>, overrides?: CallOverrides): Promise<void>;
    };
    filters: {};
    estimateGas: {
        forward(chainId: PromiseOrValue<BigNumberish>, targetAddress: PromiseOrValue<string>, gasLimit: PromiseOrValue<BigNumberish>, receiverValue: PromiseOrValue<BigNumberish>, payload: PromiseOrValue<BytesLike>, overrides?: PayableOverrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
    };
    populateTransaction: {
        forward(chainId: PromiseOrValue<BigNumberish>, targetAddress: PromiseOrValue<string>, gasLimit: PromiseOrValue<BigNumberish>, receiverValue: PromiseOrValue<BigNumberish>, payload: PromiseOrValue<BytesLike>, overrides?: PayableOverrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
    };
}
