import { Signer } from "ethers";
import type { Provider } from "@ethersproject/providers";
import type { IWormholeRelayerDelivery, IWormholeRelayerDeliveryInterface } from "../../IWormholeRelayer.sol/IWormholeRelayerDelivery";
export declare class IWormholeRelayerDelivery__factory {
    static readonly abi: readonly [{
        readonly anonymous: false;
        readonly inputs: readonly [{
            readonly indexed: true;
            readonly internalType: "address";
            readonly name: "recipientContract";
            readonly type: "address";
        }, {
            readonly indexed: true;
            readonly internalType: "uint16";
            readonly name: "sourceChain";
            readonly type: "uint16";
        }, {
            readonly indexed: true;
            readonly internalType: "uint64";
            readonly name: "sequence";
            readonly type: "uint64";
        }, {
            readonly indexed: false;
            readonly internalType: "bytes32";
            readonly name: "deliveryVaaHash";
            readonly type: "bytes32";
        }, {
            readonly indexed: false;
            readonly internalType: "enum IWormholeRelayerDelivery.DeliveryStatus";
            readonly name: "status";
            readonly type: "uint8";
        }, {
            readonly indexed: false;
            readonly internalType: "uint256";
            readonly name: "gasUsed";
            readonly type: "uint256";
        }, {
            readonly indexed: false;
            readonly internalType: "enum IWormholeRelayerDelivery.RefundStatus";
            readonly name: "refundStatus";
            readonly type: "uint8";
        }, {
            readonly indexed: false;
            readonly internalType: "bytes";
            readonly name: "additionalStatusInfo";
            readonly type: "bytes";
        }, {
            readonly indexed: false;
            readonly internalType: "bytes";
            readonly name: "overridesInfo";
            readonly type: "bytes";
        }];
        readonly name: "Delivery";
        readonly type: "event";
    }, {
        readonly anonymous: false;
        readonly inputs: readonly [{
            readonly indexed: true;
            readonly internalType: "uint64";
            readonly name: "sequence";
            readonly type: "uint64";
        }, {
            readonly indexed: false;
            readonly internalType: "uint256";
            readonly name: "deliveryQuote";
            readonly type: "uint256";
        }, {
            readonly indexed: false;
            readonly internalType: "uint256";
            readonly name: "paymentForExtraReceiverValue";
            readonly type: "uint256";
        }];
        readonly name: "SendEvent";
        readonly type: "event";
    }, {
        readonly inputs: readonly [{
            readonly internalType: "bytes[]";
            readonly name: "encodedVMs";
            readonly type: "bytes[]";
        }, {
            readonly internalType: "bytes";
            readonly name: "encodedDeliveryVAA";
            readonly type: "bytes";
        }, {
            readonly internalType: "address payable";
            readonly name: "relayerRefundAddress";
            readonly type: "address";
        }, {
            readonly internalType: "bytes";
            readonly name: "deliveryOverrides";
            readonly type: "bytes";
        }];
        readonly name: "deliver";
        readonly outputs: readonly [];
        readonly stateMutability: "payable";
        readonly type: "function";
    }, {
        readonly inputs: readonly [{
            readonly internalType: "uint16";
            readonly name: "chainId";
            readonly type: "uint16";
        }];
        readonly name: "getRegisteredWormholeRelayerContract";
        readonly outputs: readonly [{
            readonly internalType: "bytes32";
            readonly name: "";
            readonly type: "bytes32";
        }];
        readonly stateMutability: "view";
        readonly type: "function";
    }];
    static createInterface(): IWormholeRelayerDeliveryInterface;
    static connect(address: string, signerOrProvider: Signer | Provider): IWormholeRelayerDelivery;
}
