import { Signer } from "ethers";
import type { Provider } from "@ethersproject/providers";
import type { WormholeRelayerSend, WormholeRelayerSendInterface } from "../WormholeRelayerSend";
export declare class WormholeRelayerSend__factory {
    static readonly abi: readonly [{
        readonly inputs: readonly [];
        readonly name: "DeliveryProviderCannotReceivePayment";
        readonly type: "error";
    }, {
        readonly inputs: readonly [{
            readonly internalType: "address";
            readonly name: "relayer";
            readonly type: "address";
        }, {
            readonly internalType: "uint16";
            readonly name: "chainId";
            readonly type: "uint16";
        }];
        readonly name: "DeliveryProviderDoesNotSupportTargetChain";
        readonly type: "error";
    }, {
        readonly inputs: readonly [{
            readonly internalType: "address";
            readonly name: "msgSender";
            readonly type: "address";
        }, {
            readonly internalType: "address";
            readonly name: "deliveryTarget";
            readonly type: "address";
        }];
        readonly name: "ForwardRequestFromWrongAddress";
        readonly type: "error";
    }, {
        readonly inputs: readonly [{
            readonly internalType: "LocalNative";
            readonly name: "msgValue";
            readonly type: "uint256";
        }, {
            readonly internalType: "LocalNative";
            readonly name: "totalFee";
            readonly type: "uint256";
        }];
        readonly name: "InvalidMsgValue";
        readonly type: "error";
    }, {
        readonly inputs: readonly [];
        readonly name: "NoDeliveryInProgress";
        readonly type: "error";
    }, {
        readonly inputs: readonly [{
            readonly internalType: "bytes32";
            readonly name: "";
            readonly type: "bytes32";
        }];
        readonly name: "NotAnEvmAddress";
        readonly type: "error";
    }, {
        readonly inputs: readonly [{
            readonly internalType: "uint8";
            readonly name: "version";
            readonly type: "uint8";
        }, {
            readonly internalType: "uint8";
            readonly name: "expectedVersion";
            readonly type: "uint8";
        }];
        readonly name: "UnexpectedExecutionInfoVersion";
        readonly type: "error";
    }, {
        readonly anonymous: false;
        readonly inputs: readonly [{
            readonly indexed: true;
            readonly internalType: "uint64";
            readonly name: "sequence";
            readonly type: "uint64";
        }, {
            readonly indexed: false;
            readonly internalType: "LocalNative";
            readonly name: "deliveryQuote";
            readonly type: "uint256";
        }, {
            readonly indexed: false;
            readonly internalType: "LocalNative";
            readonly name: "paymentForExtraReceiverValue";
            readonly type: "uint256";
        }];
        readonly name: "SendEvent";
        readonly type: "event";
    }, {
        readonly inputs: readonly [{
            readonly internalType: "uint16";
            readonly name: "targetChain";
            readonly type: "uint16";
        }, {
            readonly internalType: "bytes32";
            readonly name: "targetAddress";
            readonly type: "bytes32";
        }, {
            readonly internalType: "bytes";
            readonly name: "payload";
            readonly type: "bytes";
        }, {
            readonly internalType: "TargetNative";
            readonly name: "receiverValue";
            readonly type: "uint256";
        }, {
            readonly internalType: "LocalNative";
            readonly name: "paymentForExtraReceiverValue";
            readonly type: "uint256";
        }, {
            readonly internalType: "bytes";
            readonly name: "encodedExecutionParameters";
            readonly type: "bytes";
        }, {
            readonly internalType: "uint16";
            readonly name: "refundChain";
            readonly type: "uint16";
        }, {
            readonly internalType: "bytes32";
            readonly name: "refundAddress";
            readonly type: "bytes32";
        }, {
            readonly internalType: "address";
            readonly name: "deliveryProviderAddress";
            readonly type: "address";
        }, {
            readonly components: readonly [{
                readonly internalType: "uint16";
                readonly name: "chainId";
                readonly type: "uint16";
            }, {
                readonly internalType: "bytes32";
                readonly name: "emitterAddress";
                readonly type: "bytes32";
            }, {
                readonly internalType: "uint64";
                readonly name: "sequence";
                readonly type: "uint64";
            }];
            readonly internalType: "struct VaaKey[]";
            readonly name: "vaaKeys";
            readonly type: "tuple[]";
        }, {
            readonly internalType: "uint8";
            readonly name: "consistencyLevel";
            readonly type: "uint8";
        }];
        readonly name: "forward";
        readonly outputs: readonly [];
        readonly stateMutability: "payable";
        readonly type: "function";
    }, {
        readonly inputs: readonly [{
            readonly internalType: "uint16";
            readonly name: "targetChain";
            readonly type: "uint16";
        }, {
            readonly internalType: "address";
            readonly name: "targetAddress";
            readonly type: "address";
        }, {
            readonly internalType: "bytes";
            readonly name: "payload";
            readonly type: "bytes";
        }, {
            readonly internalType: "TargetNative";
            readonly name: "receiverValue";
            readonly type: "uint256";
        }, {
            readonly internalType: "Gas";
            readonly name: "gasLimit";
            readonly type: "uint256";
        }];
        readonly name: "forwardPayloadToEvm";
        readonly outputs: readonly [];
        readonly stateMutability: "payable";
        readonly type: "function";
    }, {
        readonly inputs: readonly [{
            readonly internalType: "uint16";
            readonly name: "targetChain";
            readonly type: "uint16";
        }, {
            readonly internalType: "address";
            readonly name: "targetAddress";
            readonly type: "address";
        }, {
            readonly internalType: "bytes";
            readonly name: "payload";
            readonly type: "bytes";
        }, {
            readonly internalType: "TargetNative";
            readonly name: "receiverValue";
            readonly type: "uint256";
        }, {
            readonly internalType: "LocalNative";
            readonly name: "paymentForExtraReceiverValue";
            readonly type: "uint256";
        }, {
            readonly internalType: "Gas";
            readonly name: "gasLimit";
            readonly type: "uint256";
        }, {
            readonly internalType: "uint16";
            readonly name: "refundChain";
            readonly type: "uint16";
        }, {
            readonly internalType: "address";
            readonly name: "refundAddress";
            readonly type: "address";
        }, {
            readonly internalType: "address";
            readonly name: "deliveryProviderAddress";
            readonly type: "address";
        }, {
            readonly components: readonly [{
                readonly internalType: "uint16";
                readonly name: "chainId";
                readonly type: "uint16";
            }, {
                readonly internalType: "bytes32";
                readonly name: "emitterAddress";
                readonly type: "bytes32";
            }, {
                readonly internalType: "uint64";
                readonly name: "sequence";
                readonly type: "uint64";
            }];
            readonly internalType: "struct VaaKey[]";
            readonly name: "vaaKeys";
            readonly type: "tuple[]";
        }, {
            readonly internalType: "uint8";
            readonly name: "consistencyLevel";
            readonly type: "uint8";
        }];
        readonly name: "forwardToEvm";
        readonly outputs: readonly [];
        readonly stateMutability: "payable";
        readonly type: "function";
    }, {
        readonly inputs: readonly [{
            readonly internalType: "uint16";
            readonly name: "targetChain";
            readonly type: "uint16";
        }, {
            readonly internalType: "address";
            readonly name: "targetAddress";
            readonly type: "address";
        }, {
            readonly internalType: "bytes";
            readonly name: "payload";
            readonly type: "bytes";
        }, {
            readonly internalType: "TargetNative";
            readonly name: "receiverValue";
            readonly type: "uint256";
        }, {
            readonly internalType: "Gas";
            readonly name: "gasLimit";
            readonly type: "uint256";
        }, {
            readonly components: readonly [{
                readonly internalType: "uint16";
                readonly name: "chainId";
                readonly type: "uint16";
            }, {
                readonly internalType: "bytes32";
                readonly name: "emitterAddress";
                readonly type: "bytes32";
            }, {
                readonly internalType: "uint64";
                readonly name: "sequence";
                readonly type: "uint64";
            }];
            readonly internalType: "struct VaaKey[]";
            readonly name: "vaaKeys";
            readonly type: "tuple[]";
        }];
        readonly name: "forwardVaasToEvm";
        readonly outputs: readonly [];
        readonly stateMutability: "payable";
        readonly type: "function";
    }, {
        readonly inputs: readonly [];
        readonly name: "getDefaultDeliveryProvider";
        readonly outputs: readonly [{
            readonly internalType: "address";
            readonly name: "deliveryProvider";
            readonly type: "address";
        }];
        readonly stateMutability: "view";
        readonly type: "function";
    }, {
        readonly inputs: readonly [{
            readonly internalType: "uint16";
            readonly name: "targetChain";
            readonly type: "uint16";
        }];
        readonly name: "getDefaultDeliveryProviderOnChain";
        readonly outputs: readonly [{
            readonly internalType: "address";
            readonly name: "deliveryProvider";
            readonly type: "address";
        }];
        readonly stateMutability: "view";
        readonly type: "function";
    }, {
        readonly inputs: readonly [{
            readonly internalType: "uint16";
            readonly name: "targetChain";
            readonly type: "uint16";
        }];
        readonly name: "getOriginalOrDefaultDeliveryProvider";
        readonly outputs: readonly [{
            readonly internalType: "address";
            readonly name: "deliveryProvider";
            readonly type: "address";
        }, {
            readonly internalType: "address";
            readonly name: "deliveryProviderOnTarget";
            readonly type: "address";
        }];
        readonly stateMutability: "view";
        readonly type: "function";
    }, {
        readonly inputs: readonly [{
            readonly internalType: "uint16";
            readonly name: "chainId";
            readonly type: "uint16";
        }];
        readonly name: "getRegisteredWormholeRelayerContract";
        readonly outputs: readonly [{
            readonly internalType: "bytes32";
            readonly name: "";
            readonly type: "bytes32";
        }];
        readonly stateMutability: "view";
        readonly type: "function";
    }, {
        readonly inputs: readonly [{
            readonly internalType: "uint16";
            readonly name: "targetChain";
            readonly type: "uint16";
        }, {
            readonly internalType: "TargetNative";
            readonly name: "receiverValue";
            readonly type: "uint256";
        }, {
            readonly internalType: "bytes";
            readonly name: "encodedExecutionParameters";
            readonly type: "bytes";
        }, {
            readonly internalType: "address";
            readonly name: "deliveryProviderAddress";
            readonly type: "address";
        }];
        readonly name: "quoteDeliveryPrice";
        readonly outputs: readonly [{
            readonly internalType: "LocalNative";
            readonly name: "nativePriceQuote";
            readonly type: "uint256";
        }, {
            readonly internalType: "bytes";
            readonly name: "encodedExecutionInfo";
            readonly type: "bytes";
        }];
        readonly stateMutability: "view";
        readonly type: "function";
    }, {
        readonly inputs: readonly [{
            readonly internalType: "uint16";
            readonly name: "targetChain";
            readonly type: "uint16";
        }, {
            readonly internalType: "TargetNative";
            readonly name: "receiverValue";
            readonly type: "uint256";
        }, {
            readonly internalType: "Gas";
            readonly name: "gasLimit";
            readonly type: "uint256";
        }, {
            readonly internalType: "address";
            readonly name: "deliveryProviderAddress";
            readonly type: "address";
        }];
        readonly name: "quoteEVMDeliveryPrice";
        readonly outputs: readonly [{
            readonly internalType: "LocalNative";
            readonly name: "nativePriceQuote";
            readonly type: "uint256";
        }, {
            readonly internalType: "GasPrice";
            readonly name: "targetChainRefundPerGasUnused";
            readonly type: "uint256";
        }];
        readonly stateMutability: "view";
        readonly type: "function";
    }, {
        readonly inputs: readonly [{
            readonly internalType: "uint16";
            readonly name: "targetChain";
            readonly type: "uint16";
        }, {
            readonly internalType: "TargetNative";
            readonly name: "receiverValue";
            readonly type: "uint256";
        }, {
            readonly internalType: "Gas";
            readonly name: "gasLimit";
            readonly type: "uint256";
        }];
        readonly name: "quoteEVMDeliveryPrice";
        readonly outputs: readonly [{
            readonly internalType: "LocalNative";
            readonly name: "nativePriceQuote";
            readonly type: "uint256";
        }, {
            readonly internalType: "GasPrice";
            readonly name: "targetChainRefundPerGasUnused";
            readonly type: "uint256";
        }];
        readonly stateMutability: "view";
        readonly type: "function";
    }, {
        readonly inputs: readonly [{
            readonly internalType: "uint16";
            readonly name: "targetChain";
            readonly type: "uint16";
        }, {
            readonly internalType: "LocalNative";
            readonly name: "currentChainAmount";
            readonly type: "uint256";
        }, {
            readonly internalType: "address";
            readonly name: "deliveryProviderAddress";
            readonly type: "address";
        }];
        readonly name: "quoteNativeForChain";
        readonly outputs: readonly [{
            readonly internalType: "TargetNative";
            readonly name: "targetChainAmount";
            readonly type: "uint256";
        }];
        readonly stateMutability: "view";
        readonly type: "function";
    }, {
        readonly inputs: readonly [{
            readonly components: readonly [{
                readonly internalType: "uint16";
                readonly name: "chainId";
                readonly type: "uint16";
            }, {
                readonly internalType: "bytes32";
                readonly name: "emitterAddress";
                readonly type: "bytes32";
            }, {
                readonly internalType: "uint64";
                readonly name: "sequence";
                readonly type: "uint64";
            }];
            readonly internalType: "struct VaaKey";
            readonly name: "deliveryVaaKey";
            readonly type: "tuple";
        }, {
            readonly internalType: "uint16";
            readonly name: "targetChain";
            readonly type: "uint16";
        }, {
            readonly internalType: "TargetNative";
            readonly name: "newReceiverValue";
            readonly type: "uint256";
        }, {
            readonly internalType: "bytes";
            readonly name: "newEncodedExecutionParameters";
            readonly type: "bytes";
        }, {
            readonly internalType: "address";
            readonly name: "newDeliveryProviderAddress";
            readonly type: "address";
        }];
        readonly name: "resend";
        readonly outputs: readonly [{
            readonly internalType: "uint64";
            readonly name: "sequence";
            readonly type: "uint64";
        }];
        readonly stateMutability: "payable";
        readonly type: "function";
    }, {
        readonly inputs: readonly [{
            readonly components: readonly [{
                readonly internalType: "uint16";
                readonly name: "chainId";
                readonly type: "uint16";
            }, {
                readonly internalType: "bytes32";
                readonly name: "emitterAddress";
                readonly type: "bytes32";
            }, {
                readonly internalType: "uint64";
                readonly name: "sequence";
                readonly type: "uint64";
            }];
            readonly internalType: "struct VaaKey";
            readonly name: "deliveryVaaKey";
            readonly type: "tuple";
        }, {
            readonly internalType: "uint16";
            readonly name: "targetChain";
            readonly type: "uint16";
        }, {
            readonly internalType: "TargetNative";
            readonly name: "newReceiverValue";
            readonly type: "uint256";
        }, {
            readonly internalType: "Gas";
            readonly name: "newGasLimit";
            readonly type: "uint256";
        }, {
            readonly internalType: "address";
            readonly name: "newDeliveryProviderAddress";
            readonly type: "address";
        }];
        readonly name: "resendToEvm";
        readonly outputs: readonly [{
            readonly internalType: "uint64";
            readonly name: "sequence";
            readonly type: "uint64";
        }];
        readonly stateMutability: "payable";
        readonly type: "function";
    }, {
        readonly inputs: readonly [{
            readonly internalType: "uint16";
            readonly name: "targetChain";
            readonly type: "uint16";
        }, {
            readonly internalType: "bytes32";
            readonly name: "targetAddress";
            readonly type: "bytes32";
        }, {
            readonly internalType: "bytes";
            readonly name: "payload";
            readonly type: "bytes";
        }, {
            readonly internalType: "TargetNative";
            readonly name: "receiverValue";
            readonly type: "uint256";
        }, {
            readonly internalType: "LocalNative";
            readonly name: "paymentForExtraReceiverValue";
            readonly type: "uint256";
        }, {
            readonly internalType: "bytes";
            readonly name: "encodedExecutionParameters";
            readonly type: "bytes";
        }, {
            readonly internalType: "uint16";
            readonly name: "refundChain";
            readonly type: "uint16";
        }, {
            readonly internalType: "bytes32";
            readonly name: "refundAddress";
            readonly type: "bytes32";
        }, {
            readonly internalType: "address";
            readonly name: "deliveryProviderAddress";
            readonly type: "address";
        }, {
            readonly components: readonly [{
                readonly internalType: "uint16";
                readonly name: "chainId";
                readonly type: "uint16";
            }, {
                readonly internalType: "bytes32";
                readonly name: "emitterAddress";
                readonly type: "bytes32";
            }, {
                readonly internalType: "uint64";
                readonly name: "sequence";
                readonly type: "uint64";
            }];
            readonly internalType: "struct VaaKey[]";
            readonly name: "vaaKeys";
            readonly type: "tuple[]";
        }, {
            readonly internalType: "uint8";
            readonly name: "consistencyLevel";
            readonly type: "uint8";
        }];
        readonly name: "send";
        readonly outputs: readonly [{
            readonly internalType: "uint64";
            readonly name: "sequence";
            readonly type: "uint64";
        }];
        readonly stateMutability: "payable";
        readonly type: "function";
    }, {
        readonly inputs: readonly [{
            readonly internalType: "uint16";
            readonly name: "targetChain";
            readonly type: "uint16";
        }, {
            readonly internalType: "address";
            readonly name: "targetAddress";
            readonly type: "address";
        }, {
            readonly internalType: "bytes";
            readonly name: "payload";
            readonly type: "bytes";
        }, {
            readonly internalType: "TargetNative";
            readonly name: "receiverValue";
            readonly type: "uint256";
        }, {
            readonly internalType: "Gas";
            readonly name: "gasLimit";
            readonly type: "uint256";
        }, {
            readonly internalType: "uint16";
            readonly name: "refundChain";
            readonly type: "uint16";
        }, {
            readonly internalType: "address";
            readonly name: "refundAddress";
            readonly type: "address";
        }];
        readonly name: "sendPayloadToEvm";
        readonly outputs: readonly [{
            readonly internalType: "uint64";
            readonly name: "sequence";
            readonly type: "uint64";
        }];
        readonly stateMutability: "payable";
        readonly type: "function";
    }, {
        readonly inputs: readonly [{
            readonly internalType: "uint16";
            readonly name: "targetChain";
            readonly type: "uint16";
        }, {
            readonly internalType: "address";
            readonly name: "targetAddress";
            readonly type: "address";
        }, {
            readonly internalType: "bytes";
            readonly name: "payload";
            readonly type: "bytes";
        }, {
            readonly internalType: "TargetNative";
            readonly name: "receiverValue";
            readonly type: "uint256";
        }, {
            readonly internalType: "Gas";
            readonly name: "gasLimit";
            readonly type: "uint256";
        }];
        readonly name: "sendPayloadToEvm";
        readonly outputs: readonly [{
            readonly internalType: "uint64";
            readonly name: "sequence";
            readonly type: "uint64";
        }];
        readonly stateMutability: "payable";
        readonly type: "function";
    }, {
        readonly inputs: readonly [{
            readonly internalType: "uint16";
            readonly name: "targetChain";
            readonly type: "uint16";
        }, {
            readonly internalType: "address";
            readonly name: "targetAddress";
            readonly type: "address";
        }, {
            readonly internalType: "bytes";
            readonly name: "payload";
            readonly type: "bytes";
        }, {
            readonly internalType: "TargetNative";
            readonly name: "receiverValue";
            readonly type: "uint256";
        }, {
            readonly internalType: "LocalNative";
            readonly name: "paymentForExtraReceiverValue";
            readonly type: "uint256";
        }, {
            readonly internalType: "Gas";
            readonly name: "gasLimit";
            readonly type: "uint256";
        }, {
            readonly internalType: "uint16";
            readonly name: "refundChain";
            readonly type: "uint16";
        }, {
            readonly internalType: "address";
            readonly name: "refundAddress";
            readonly type: "address";
        }, {
            readonly internalType: "address";
            readonly name: "deliveryProviderAddress";
            readonly type: "address";
        }, {
            readonly components: readonly [{
                readonly internalType: "uint16";
                readonly name: "chainId";
                readonly type: "uint16";
            }, {
                readonly internalType: "bytes32";
                readonly name: "emitterAddress";
                readonly type: "bytes32";
            }, {
                readonly internalType: "uint64";
                readonly name: "sequence";
                readonly type: "uint64";
            }];
            readonly internalType: "struct VaaKey[]";
            readonly name: "vaaKeys";
            readonly type: "tuple[]";
        }, {
            readonly internalType: "uint8";
            readonly name: "consistencyLevel";
            readonly type: "uint8";
        }];
        readonly name: "sendToEvm";
        readonly outputs: readonly [{
            readonly internalType: "uint64";
            readonly name: "sequence";
            readonly type: "uint64";
        }];
        readonly stateMutability: "payable";
        readonly type: "function";
    }, {
        readonly inputs: readonly [{
            readonly internalType: "uint16";
            readonly name: "targetChain";
            readonly type: "uint16";
        }, {
            readonly internalType: "address";
            readonly name: "targetAddress";
            readonly type: "address";
        }, {
            readonly internalType: "bytes";
            readonly name: "payload";
            readonly type: "bytes";
        }, {
            readonly internalType: "TargetNative";
            readonly name: "receiverValue";
            readonly type: "uint256";
        }, {
            readonly internalType: "Gas";
            readonly name: "gasLimit";
            readonly type: "uint256";
        }, {
            readonly components: readonly [{
                readonly internalType: "uint16";
                readonly name: "chainId";
                readonly type: "uint16";
            }, {
                readonly internalType: "bytes32";
                readonly name: "emitterAddress";
                readonly type: "bytes32";
            }, {
                readonly internalType: "uint64";
                readonly name: "sequence";
                readonly type: "uint64";
            }];
            readonly internalType: "struct VaaKey[]";
            readonly name: "vaaKeys";
            readonly type: "tuple[]";
        }];
        readonly name: "sendVaasToEvm";
        readonly outputs: readonly [{
            readonly internalType: "uint64";
            readonly name: "sequence";
            readonly type: "uint64";
        }];
        readonly stateMutability: "payable";
        readonly type: "function";
    }, {
        readonly inputs: readonly [{
            readonly internalType: "uint16";
            readonly name: "targetChain";
            readonly type: "uint16";
        }, {
            readonly internalType: "address";
            readonly name: "targetAddress";
            readonly type: "address";
        }, {
            readonly internalType: "bytes";
            readonly name: "payload";
            readonly type: "bytes";
        }, {
            readonly internalType: "TargetNative";
            readonly name: "receiverValue";
            readonly type: "uint256";
        }, {
            readonly internalType: "Gas";
            readonly name: "gasLimit";
            readonly type: "uint256";
        }, {
            readonly components: readonly [{
                readonly internalType: "uint16";
                readonly name: "chainId";
                readonly type: "uint16";
            }, {
                readonly internalType: "bytes32";
                readonly name: "emitterAddress";
                readonly type: "bytes32";
            }, {
                readonly internalType: "uint64";
                readonly name: "sequence";
                readonly type: "uint64";
            }];
            readonly internalType: "struct VaaKey[]";
            readonly name: "vaaKeys";
            readonly type: "tuple[]";
        }, {
            readonly internalType: "uint16";
            readonly name: "refundChain";
            readonly type: "uint16";
        }, {
            readonly internalType: "address";
            readonly name: "refundAddress";
            readonly type: "address";
        }];
        readonly name: "sendVaasToEvm";
        readonly outputs: readonly [{
            readonly internalType: "uint64";
            readonly name: "sequence";
            readonly type: "uint64";
        }];
        readonly stateMutability: "payable";
        readonly type: "function";
    }];
    static createInterface(): WormholeRelayerSendInterface;
    static connect(address: string, signerOrProvider: Signer | Provider): WormholeRelayerSend;
}
